#include "pch.hpp"
#include "chalcopyrite.hpp"
#include "mainwnd.hpp"

#define MINIMAL_USE_PROCESSHEAPSTRING
#include "MinimalPath.hpp"

// VOg
HINSTANCE g_hInstance;
Minimal::ProcessHeapStringT<char> g_appPath;
CProfileIO g_settings;

static LPARAM Application_Run()
{
	MSG msg;
	while(::GetMessage(&msg, NULL, 0, 0) > 0) {
		::TranslateMessage(&msg);
		::DispatchMessage(&msg);
	}
	return msg.lParam;
}

#ifndef _DEBUG
int main()
{
	char appPath[1025];
	::GetModuleFileName(GetModuleHandle(NULL), appPath, sizeof appPath);
	::PathRemoveFileSpec(appPath);
	g_appPath = appPath;

	Minimal::ProcessHeapPathA settingPath = g_appPath;
	settingPath /= "hikouseki.ini";
	OutputDebugString(settingPath);
	g_settings.SetPath(settingPath);

	return !MainWindow_Initialize() ? -1
		: Application_Run();
}
#else
int APIENTRY WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	g_hInstance = (HINSTANCE)GetModuleHandle(NULL);

	char appPath[1025];
	::GetModuleFileName(GetModuleHandle(NULL), appPath, sizeof appPath);
	::PathRemoveFileSpec(appPath);
	g_appPath = appPath;


	return 	
		!MainWindow_Initialize() ? -1
		: Application_Run();
}
#endif
